#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iomanip>
#include <stdlib.h>
#include <algorithm>
#include <vector>


using namespace std;

    string fvardas;
    fstream failas;


    /*Sukuriama struktura*/
struct Salis
{
    string Kryptis;
    double Kaina;
    int Laikas;




Salis(string kryptis, int kaina, int laikas)
{
    Kryptis=kryptis;
    Kaina=kaina;
    Laikas=laikas;
}


};



/* Funkcijoje atidaromas failas ir i ji irasoma informacija*/
void FailoAtidarymasIrasymas()
{

    string info;
    int k,l;

   failas.open("duomenys.txt", ios::in |ios::app );

if(failas.is_open()){
     cout << "Iveskite informacija \n ";

cout << "Salis: ";
cin >> info;
cout << "Kaina: ";
cin >> k;
cout << "Trukme: ";
cin >> l;

   failas<< setw(11)<<left<< info << " " << setw(9)<<left<<k << " " <<setw(7)<<left<< l <<endl;


failas.close();
    }
    else {
        cout << " Tokio failo nera " << endl;
    }

    return ;
}







/*Funkcija istrina duomenis ir vel juos iraso*/
void FailoTrynimasSukurimas ()
{

    string info;


  failas.open("duomenys.txt", ios::trunc | ios::out);
  failas.close();

        ofstream failas("duomenys.txt",ios::in | ios::app);

failas << "* Salis *"<< "* Kaina *" << "* Trukme *" <<endl;
failas <<setw(11)<<left<< "Austrija" << " " << setw(9)<<left<<"500" << " " <<setw(7)<<left<< "7" <<endl;
failas <<setw(11)<<left<< "Belgija" << " " << setw(9)<<left<<"100" << " " <<setw(7)<<left<< "2" <<endl;
failas <<setw(11)<<left<< "Austrija" << " " << setw(9)<<left<<"300" << " " <<setw(7)<<left<< "3" <<endl;
failas <<setw(11)<<left<< "Belgija" << " " << setw(9)<<left<<"400" << " " <<setw(7)<<left<< "5" <<endl;
failas <<setw(11)<<left<< "Graikija" << " " << setw(9)<<left<<"200" << " " <<setw(7)<<left<< "3" <<endl;
failas <<setw(11)<<left<< "Lenkija" << " " << setw(9)<<left<<"600" << " " <<setw(7)<<left<< "10" <<endl;
     failas.close();


return;
}










/* duomenu rikiavmas abeceles tvarka*/
void Rikiavimaspagalvarda()
{
        string info;
        string f;

   failas.open("duomenys.txt",ios::in);
   vector<string>rows;


    while (!failas.eof())
    {

  getline(failas,f);
  rows.push_back(f);

  }
sort(rows.begin(),rows.end());

vector<string>::iterator iterator=rows.begin();
for(;iterator !=rows.end(); ++iterator)
    cout << *iterator << endl;
    getchar();


failas.close();

    return ;
}







/*Duomenu rikiavimas burbulo metodu*/
void RikiavimasPagalKaina(Salis sal[], int kiekis)
{

   for(int i=0;i<kiekis;i++)
    for(int j=1;j<kiekis; j++)
   if(sal[j-1].Kaina>sal[j].Kaina)
    {
        Salis t=sal[j-1];
        sal[j-1]=sal[j];
        sal[j]=t;
}

for(int i=0; i<kiekis; i++)
{
cout <<setw(8)<<left <<sal[i].Kryptis<< "    " << setw(7)<<left<< sal[i].Kaina << "   " << setw(15)<<left << sal[i].Laikas <<endl;
}


return;
}


/*Paieska*/
void Paieska (Salis sal[], int kiekis)
{

    string kryptis;

double laikasNuo, laikasIki, kainaNuo, kainaIki;
bool rastas = false;
cout << "Ieskomas salis: ";
cin >> kryptis;
cout << "Keliones kaina nuo: ";
cin >> kainaNuo;
cout << "Keliones kaina iki: ";
cin >> kainaIki;
cout << "Keliones trukme nuo: ";
cin >> laikasNuo;
cout << "Keliones trukme iki: ";
cin >> laikasIki;
cout << endl;
for (int i = 0; i < kiekis; i++) {

if (sal[i].Kaina <= kainaIki
&& sal[i].Kaina >= kainaNuo
&& sal[i].Kryptis == kryptis
&& sal[i].Laikas <= laikasIki
&& sal[i].Laikas >= laikasNuo)

{

cout << "Rasta kryptis: ";
cout <<setw(8)<<left <<" Salis " << sal[i].Kryptis<< endl;
cout << setw(22)<<right<<" Kaina " <<"  "<< sal[i].Kaina <<" eur"<< endl;
cout << setw(23)<<right <<" Laikas " <<"  "<< sal[i].Laikas <<" dienos"<<endl;


rastas = true;

}

}
if (!rastas)

cout << "Kelioniu nerasta!";

}




/*Duomenu pridejimas i faila*/
void DuomenuPridejimas()
{
    ofstream failas("duomenys.txt",ios::in | ios::app);

failas << "* Salis *"<< "* Kaina *" << "* Trukme *" <<endl;
failas <<setw(11)<<left<< "Austrija" << " " << setw(9)<<left<<"500" << " " <<setw(7)<<left<< "7" <<endl;
failas <<setw(11)<<left<< "Belgija" << " " << setw(9)<<left<<"100" << " " <<setw(7)<<left<< "2" <<endl;
failas <<setw(11)<<left<< "Austrija" << " " << setw(9)<<left<<"300" << " " <<setw(7)<<left<< "3" <<endl;
failas <<setw(11)<<left<< "Belgija" << " " << setw(9)<<left<<"400" << " " <<setw(7)<<left<< "5" <<endl;
failas <<setw(11)<<left<< "Graikija" << " " << setw(9)<<left<<"200" << " " <<setw(7)<<left<< "3" <<endl;
failas <<setw(11)<<left<< "Lenkija" << " " << setw(9)<<left<<"600" << " " <<setw(7)<<left<< "10" <<endl;
     failas.close();

         return ;
}



/*Duomenu isvalymas is failo*/
void Isvalymas()
{
    failas.open("duomenys.txt", ios::trunc | ios::out);
  failas.close();

  return ;
}


/* pagrindine funkcija */
int main()
{
int const kiekis = 6;

/*Aprasomas masymas*/
Salis Salys[kiekis]={

Salis("Austrija",500,7),
Salis("Belgija",100,2),
Salis("Austrija",300,3),
Salis("Belgija",400,5),
Salis("Graikija",200,3),
Salis("Lenkija",600,10)
};
    int k=0;
    k=0;
while (k>=0 && k<=9)
{
    /* Meniu pasirinkimas */
    cout<<endl;
    cout<<"Arvydas Juodagalvis ISI-18I gr. "<<endl;
    cout<<"--------------------------------------------------------------------"<<endl;
    cout<<"Pasirinkite veiksma, kuri norite atlikti: "<<endl;
    cout<<"1 Failo atidarymas ir irasymas"<<endl;
    cout<<"2 Failo isvalymas, duomenu pridejimas" <<endl;
    cout<<"3 Failo rikiavimas pagal varda" <<endl;
    cout<<"4 Duomenu rikiavima pagal kaina" <<endl;
    cout<<"5 Duomenu pridejimas" <<endl;
    cout<<"6 Failo isvalymas" <<endl;
    cout<<"7 Paieska" <<endl;
    cout<<"8 Baigti"<<endl;
    cout<<"--------------------------------------------------------------------"<<endl;
    cin>>k;

/* switch konstrukcija */

switch (k)
    {
    case 1:
        FailoAtidarymasIrasymas();
    break;
    case 2:
        FailoTrynimasSukurimas();
    break;
    case 3:
        Rikiavimaspagalvarda();
        break;
    case 4:
        RikiavimasPagalKaina(Salys, kiekis);
        break;
    case 5:
        DuomenuPridejimas();
        break;
    case 6:
        Isvalymas();
        break;
    case 7:
        Paieska(Salys, kiekis);
        break;
    case 8:
        default:
    {
       cout<<"Baigti darba"<<endl;
       return 1;
    }




}
}


}
